// Copyright 2006 all rights reserved; see LICENSE file for BSD-style license

package edu.berkeley.sbp.bind;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.util.*;
import edu.berkeley.sbp.bind.*;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;

public class RawBindingFunctor<T> implements TreeFunctor<T,Object>, ToJava {
    private Binding _binding;
    private String _toString;
    public RawBindingFunctor(String toString, Binding binding) {
        this._binding = binding;
        this._toString = toString;
    }
    public String toString() {
        return _toString;
    }
    public void toJava(StringBuffer sb) {
        sb.append("new RawBindingFunctor(");
        sb.append("\"");
        sb.append(StringUtil.toJavaString(_toString));
        sb.append("\", ");
        _binding.toJava(sb);
        sb.append(")");
    }
    public Object invoke(Iterable<Tree<T>> t) {
        return _binding.invoke(new Object[] { t });           
    }
}
